function WPpsd_var=WPspectrum(sig,Wlevel,Wreg)
%%        INPUTS
% sig: input signal
% Wlevel: Wavelet Packet Analysis at level ``Wlevel''.
% Wreg:   Wavelet Packet filtering with regularity (order) ``Wreg''.
%%        OUTPUTS
% WPpsd_var:
%%
% Frequency 2^Wlevel points
p=0:1:2^Wlevel-1;
n=int2gray(p);
WPpsd_var=zeros(1,2^Wlevel);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Wavelet Packet Spectrum at Wlevel with Wreg
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
WTree=wpdec(sig,Wlevel,Wreg);
for k=1:2^Wlevel
    Yjk=wpcoef(WTree,[Wlevel n(k)]);
    WPpsd_var(k)=var(Yjk);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright: am.atto@telecom-bretagne.eu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%