function  g = int2gray(k)
%  g = int2gray(k) = G(k+1) ,  where  G = grays(n)  for
%  n  big enough,  quickly without generating all of  G ,
%  but only if nonnegative integer  k <= bitmax .  See
%  also  grays.m,  grays2int.m  and  graystep.m .
%                                 W. Kahan,  8 July 2007

if(any(any( (k<0)|(k~=round(k))|(k>bitmax) ))),  K = k,
    error(' int2gray(K)  needs an array K of small nonnegative integers.')
  end
g = bitxor(k, fix(0.5*k)) ;

